using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using MessageBoxGenerator;

namespace Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Type messageBoxIcon = MessageBoxIcon.Asterisk.GetType();

            int[] values = new int[] { 0, 16, 32, 48 };

            this.comboBox2.Tag = values;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int buttonIndex = (this.comboBox1.SelectedIndex > -1) ? this.comboBox1.SelectedIndex : 0;
            int iconIndex = (this.comboBox2.SelectedIndex > -1) ? this.comboBox2.SelectedIndex : 0;

            int[] iconValues = (int[])this.comboBox2.Tag;

            MessageBox.Show(
                this.txtMessage.Text,
                this.txtCaption.Text,
                (MessageBoxButtons)buttonIndex,
                (MessageBoxIcon)(iconValues[iconIndex])
            );
        }

        private DialogResult GetDialogResult(string result)
        {
            DialogResult dialogResult = DialogResult.None;
            switch (result)
            {
                case "Abort":
                    dialogResult = DialogResult.Abort;
                    break;

                case "Cancel":
                    dialogResult = DialogResult.Cancel;
                    break;

                case "Ignore":
                    dialogResult = DialogResult.Ignore;
                    break;

                case "No":
                    dialogResult = DialogResult.No;
                    break;

                case "OK":
                    dialogResult = DialogResult.OK;
                    break;

                case "Retry":
                    dialogResult = DialogResult.Retry;
                    break;

                case "Yes":
                    dialogResult = DialogResult.Yes;
                    break;
            }

            return dialogResult;
        }

        private Button CreateButton(string message, DialogResult result)
        {
            Button button = new Button();
            button.Text = message;
            button.DialogResult = result;
            return button;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FormMessage form = new FormMessage();

            Button button1 = null;
            Button button2 = null;
            Button button3 = null;

            int buttonCount = (int)this.numericUpDown1.Value;

            switch (buttonCount)
            {
                case 1:

                    button1 = this.CreateButton(this.txtButton1.Text, this.GetDialogResult(this.cboResult1.SelectedItem.ToString()));
                    break;

                case 2:

                    button1 = this.CreateButton(this.txtButton1.Text, this.GetDialogResult(this.cboResult1.SelectedItem.ToString()));
                    button2 = this.CreateButton(this.txtButton2.Text, this.GetDialogResult(this.cboResult2.SelectedItem.ToString()));
                    break;

                case 3:

                    button1 = this.CreateButton(this.txtButton1.Text, this.GetDialogResult(this.cboResult1.SelectedItem.ToString()));
                    button2 = this.CreateButton(this.txtButton2.Text, this.GetDialogResult(this.cboResult2.SelectedItem.ToString()));
                    button3 = this.CreateButton(this.txtButton3.Text, this.GetDialogResult(this.cboResult3.SelectedItem.ToString()));
                    break;
            }

            if (form.Show(
                    this.txtMessage.Text,
                    this.txtCaption.Text,
                    buttonCount,
                    button1,
                    button2,
                    button3,
                    this.txtIconFile.Text
                ) == DialogResult.OK
            )
            {
                MessageBox.Show("");

            }
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            switch ((int)this.numericUpDown1.Value)
            {
                case 0:

                    this.groupBox1.Hide();
                    this.groupBox2.Hide();
                    this.groupBox3.Hide();
                    break;

                case 1:

                    this.groupBox1.Show();
                    this.groupBox2.Hide();
                    this.groupBox3.Hide();
                    break;

                case 2:

                    this.groupBox1.Show();
                    this.groupBox2.Show();
                    this.groupBox3.Hide();
                    break;

                case 3:

                    this.groupBox1.Show();
                    this.groupBox2.Show();
                    this.groupBox3.Show();
                    break;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.numericUpDown1.Value = 1;

            string[] dialogResultList = Enum.GetNames(DialogResult.OK.GetType());

            this.cboResult1.Items.AddRange(dialogResultList);
            this.cboResult2.Items.AddRange(dialogResultList);
            this.cboResult3.Items.AddRange(dialogResultList);

            this.cboResult1.SelectedIndex = 0;
            this.cboResult2.SelectedIndex = 0;
            this.cboResult3.SelectedIndex = 0;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                this.txtIconFile.Text = ofd.FileName;
            }
        }
    }
}